\documentclass[pdftex]{refrep}
\usepackage{makeidx}
\usepackage{manfnt}
\usepackage{marvosym}
\usepackage{hyperref}
\usepackage{url}
\usepackage{graphicx}
\usepackage[cp1250]{inputenc}
\usepackage{fancybox}
\usepackage{amsmath,amsfonts,amssymb}
\usepackage{listings}
\lstset{extendedchars=true, language=Pascal, basicstyle=\small \ttfamily, mathescape=true}
\graphicspath{{figures/}}
\hypersetup{pdfpagemode=UseNone,
colorlinks=true,
pdfstartview=FitH,
citecolor=darkblue
}
\newcommand{\underscorett}[0]{\texttt{\_}\hspace{0.15em}}
\newcommand{\scilab}[1]{\lstinline[basicstyle=\normalsize \ttfamily]{#1}}
\newcommand{\margin}[1]{\marginlabel{\color{darkred}#1}}
\newtheorem{theorem}{Theorem}
\newtheorem{corollary}{Corollary}         
\newtheorem{lemma}{Lemma}          
\newtheorem{proposition}{Proposition}
\newtheorem{definition}{Definition}

\makeindex
% \renewcommand{\attentionsymbol}{{\Large \dbend}}

\newenvironment{warning}{
\noindent\\\hrule
\attention[\Huge \Huge \vspace*{-0.3em} \Stopsign\vspace{0.1em}]\noindent}{\noindent\smallskip\hrule}
\newenvironment{information}{\smallskip\hrule\attention[\Huge \Large \dbend]\noindent}{\noindent\hrule\smallskip}
\title{The LRP Toolkit User's Manual}
\author{L. Hladowski, B.Cichy, K.Galkowski, E.Rogers}

\begin{document}
\definecolor{darkblue}{rgb}{0,0,0.7}
\definecolor{darkred}{rgb}{0.5,0,0}
\maketitle
\pagestyle{headings}
\chapter{Introduction}
The LRP Toolkit\footnote{ 
This manual covers the %
\input "../Version.txt"
}
is a powerful set of utilities to simplify the development
of new algorithms based on the Linear Repetitive Process (LRP) settings.
The Toolkit is ment to be used within the Scilab environment (see \url{www.scilab.org} 
for details). Before exploring the Toolkit functions it is necessary to 
introduce some theoretical background. 
\section{The Linear Repetitive Process --- theory}
Repetitive processes\index{Repetitive processes} are a distinct class of 2D systems (i.e.
information propagation in two independent directions) of both
system theoretic and applications interest. The essential unique
characteristic of such a process is a series of sweeps, termed
passes, through a set of dynamics, defined over a fixed finite
duration known as the pass length (denoted by $\alpha < + \infty $).
On each pass an output, termed the pass profile, is produced which
acts as a forcing function on, and hence contributes to, the
dynamics of the next pass profile. This, in turn, leads to the
unique control problem in that the output sequence of pass profiles
generated can contain oscillations that increase in amplitude in the
pass-to-pass direction. Hence these processes propagate information
in two separate directions, i.e. from pass-to-pass and along a pass
respectively.

Physical examples\index{Linear Repetitive process!Applications} 
include long-wall coal cutting and metal rolling
operations (see, for example,~\cite{Rogers92-1}). Also, in recent
years applications have arisen where adopting a repetitive process
setting for analysis has distinct advantages over alternatives. For
example, they can be used to analyze an important class  of
iterative learning control\index{Iterative Learning Control} (ILC\index{ILC|see{Iterative Learning Control}}) schemes~\cite{Owens2000-1}. More
recently another application has arisen in the context of self-servo
writing in disk drives~\cite{Melkote03} and there are as yet
unexploited links with one approach to the analysis of spatially
interconnected systems~\cite{DAndrea2003-1}. Attempts to control
these using standard ("classical" 1D) systems theory/algorithms fail
(except in a few very restrictive special cases) precisely because
such approaches ignore the inherent 2D structure of repetitive
processes, i.e. information propagation occurs in two distinct
directions.
Here we consider so-called discrete linear repetitive
processes\index{Linear Repetitive Process} which can arise either from direct modelling of a physical
process or as a result of sampling the dynamics of a differential
process in the along the pass direction.  

\margin{The state space model}
The state space
model~\cite{Rogers92-1}\index{Linear Repetitive Process!Model} of such a process has the following form
over $0 \leq p < \alpha,\: k \geq 0$ where $k$ denotes the pass
number or index

\begin{small}
\begin{equation}
\label{LRP}
\begin{array}{rcl}
x_{k+1}(p+1) &=&Ax_{k+1}(p)+Bu_{k+1}(p)+B_{0}y_{k}(p)\\
y_{k+1}(p) &=&Cx_{k+1}(p)+Du_{k+1}(p)+D_{0}y_{k}(p)
\end{array}
\end{equation}
\end{small}

\noindent
Here, on pass $k,$ $x_{k}(p)\in {\mathbb{R}}^{n}$ denotes the state vector, $ y_{k}(p)\in {\mathbb{R}}^{m}$ denotes
the pass profile vector, and $u_{k}(p)\in { \mathbb{R}}^{r}$ denotes the vector of control inputs.

\margin{Boundary conditions}
To complete the process description, it is necessary to specify the boundary 
conditions\index{Linear Repetitive Process!Boundary conditions}, i.e. the initial state vector
at the beginning of each pass and the initial pass profile. Here, no loss of generality arises from assuming
\begin{equation}
\label{boundaryConditions}
\begin{array}{rcl}
    x_{k + 1}(0) &=& d_{k+1},\: k \geq 0,\\
    y_{0}(p) &=& f(p),
\end{array}
\end{equation}
where the $n \times 1$ vector $d_{k+1}$ contains known constant
entries and $f(p)$ is an $m \times 1$ vector whose entries are known functions of $p$.

\subsection{Stability}
The stability theory \cite{Rogers92-1} for linear repetitive
processes\index{Linear Repetitive Process!Stability} consists of two basic concepts, termed asymptotic
stability\index{Linear Repetitive Process!Stability!Asymptotic} and stability along the 
pass\index{Linear Repetitive Process!Stability!Along the pass} respectively. Noting again
the unique control problem, these properties demand that bounded
sequences of inputs produce bounded sequences of pass profiles where
`bounded' is defined in term of the norm on the underlying function
space. Asymptotic stability guarantees this property over the finite
and fixed pass length and as a consequence there exists the
so-called limit pass profile, i.e. after the sufficient number of
passes the process dynamics can be replaced by those of a 1D
discrete linear system. The fact that the pass length is finite,
however, means that this limit profile could be unstable (as a 1D
discrete linear system). (Over a finite duration even an unstable 1D
linear system is guaranteed to produce a bounded output).
 Stability along the pass prevents this situation from arising by demanding the boundedness property uniformly, i.e.
 independent of the pass length.  (It is easy to see that asymptotic stability is a
necessary condition for stability along the pass.)

Many sets of necessary and sufficient conditions for these
properties are known and some of them can be tested by direct
application of 1D linear systems stability tests, e.g. Nyquist
plots.  A major drawback, however, is that these do not provide a
basis on which to also address the question of control law design
for stability and/or performance.  This has led in recent years to
the use of Linear Matrix Inequality (LMI) techniques (see e.g.
\cite{Boyd94-1}) and there now exists a large volume of results on
the design of physically implementable control laws (for the
detailed description refer e.g. to~\cite{SulikowskiPHD,Galkowski2003b} and
references therein.)

The unique control problem for the Linear Repetitive Processes is that the output
sequence of pass profiles ${y_k}$, $k\geq 0$ can contain oscillations which can increase in
amplitude in the from pass to pass direction ($k$). Hence a natural definition of
stability is to request that bounded input sequences produce bounded output (pass
profiles) sequences.

Stability theory (Rogers and Owens (1992)) for LRPs is based on an abstract
model of process dynamics in a Banach space (here denoted by $E_\alpha$) of the form
\begin{equation}
\label{BanachSpaceSystem}
y_{k+1} = L_\alpha y_k + b_{k+1}, k \geq 0
\end{equation}
In this model, $y_k \in E_{\alpha}$ denotes the pass profile on the pass $k$, $L_\alpha$
is a bounded linear operator which maps $E_\alpha$ into itself and $b_{k+1} \in W_\alpha$,
where $W_\alpha$ is a linear subspace of $E_\alpha$.
Also, the term $L_{\alpha}y_k$ describes the contribution of the pass $k$ to
the pass $k+1$, and $b_{k+1}$ represents the inputs and other effects which enter on the
current pass.

\begin{definition}\cite{Rogers92-1,Benton00,SulikowskiPHD}
Suppose that $||\cdot||$ denotes the norm on $E_\alpha$.
Then the so-called asymptotic stability holds provided there exist real numbers
$M_\alpha > 0$ and $\lambda_\alpha \in \left(0, 1\right)$ such that
$||L_\alpha^k || \leq M_\alpha\lambda_\alpha^k$, $k\geq 0$
(where $|| \cdot ||$ is also used to denote the induced operator norm).
\end{definition}

\begin{theorem}\cite{Rogers92-1}\label{asymptotic1}
\margin{Asymptotic stability}
The linear repetitive process described by (\ref{LRP}) is asymptotically stable
if, and only if
\begin{equation*}
   \operatorname{r}(D_0)<1
\end{equation*}
where $\operatorname{r}$ denotes the spectral radius.
\end{theorem}
The equivalent theorem using the Linear Matrix Inequalities (LMI) techniques
can be formulated as
\begin{theorem}\cite{Sulikowski2005a}\label{asymptotic2}
\margin{Asymptotic stability --- LMI}
The linear repetitve process of (\ref{LRP}) is asymptotically stable if, and only if there
exists a matrix $Q \succ 0$ of appropriate dimensions such that the following
LMI holds:
\begin{equation*}
  D_0^T Q D_0 - Q \prec 0
\end{equation*}
\end{theorem}

The asymptotic stability guarantees the existence of a limit profile but it does
not guarantee that this limit profile treated as a 1D system (under the assumption
that $\alpha \rightarrow \infty$) is stable. The reason for that is the fact that asymptotic stability does not concern dynamics along the pass (along the $p$ dimension).

Mostly, the cases where the limit pass profile is unstable as a 1D linear system are not
acceptable. Hence a stronger concept of stability, i.e., stability along the pass must
be used. This stronger stability demands the BIBO property to hold independently
of dynamics, i.e., in the direction along the pass ($p$) and from pass to pass ($k$).

Introduce the formal definition of stability along the pass as follows:
\begin{definition}\cite{Rogers92-1,Benton00,SulikowskiPHD}
In terms of the abstract model of (\ref{BanachSpaceSystem}),
stability along the pass holds provided that there exist real numbers
$M_\infty > 0$ and $\lambda_\infty \in (0, 1)$, which are independent
of $\alpha$ such that $||L_\alpha^{k}||\leq M_\infty\lambda_\infty^k$, $k\geq 0$.
\end{definition}

\begin{theorem}\cite{Galkowski03-1}
Discrete linear repetitive process described by~(\ref{LRP}) and
(\ref{boundaryConditions}) is stable along the pass if, and only if, the 2D
characteristic polynomial
\begin{align}
 \label{th:eq:1}
\begin{split}
 C(z_1,z_2):=\det
 \begin{bmatrix}
    I_n-z_1A & -z_1B_0\\
    -z_2C & I_m - z_2D_0
 \end{bmatrix} \ne 0\\
 \forall (z_1, z_2) \in \bar{U}^2
\end{split}
\end{align}
where $\bar{U}^2 = \operatorname{diag}{(z_1, z_2):|z_1| \leq 1, |z_2| \leq 1}$.
\end{theorem}
Theorem \ref{th:eq:1} is very difficult to use in practice. Note that it requires
to check an infinite number of values. To overcome this problem it is recommended to
use the following theorem.
\begin{theorem}
\label{th:stab:none:1}\cite{Galkowski03-1}
\margin{Stability along the pass}
Discrete linear repetitive process described by~(\ref{LRP}) and
(\ref{boundaryConditions}) are stable
along the pass if there exist matrices $P=P^T\succ0$ and $Q=Q^T\succ0$ satisfying the
following LMI
\begin{align}
    \begin{bmatrix}
        \widehat{A}^T_1 P \widehat{A}_1 + Q -P & \widehat{A}^T_1 P \widehat{A}_2\\
        \widehat{A}^T_2 P \widehat{A}_1 & \widehat{A}^T_2 P \widehat{A}_2 - Q
    \end{bmatrix}\prec0
    \label{th:stab:1}
\end{align}
\end{theorem}
The proof can be found in e.g. \cite{Galkowski2003b}. Note that theorem
\ref{th:stab:none:1} is only sufficient condition.

In addition to the most important stability definitions (asymptotic and along the pass), 
the Toolkit includes the tests for the so-called practical stability. This notion lies 
between the asymptotic and along the pass stability. The conditions for this type of stability 
to hold can be summarized as the following theorem
\begin{theorem}\label{practical1}\cite{GramackiPHD}
\margin{Practical stability}
The linear repetitive process described by (\ref{LRP}) is practically stable
if, and only if
\begin{equation*}
\begin{array}{rcl}
   \operatorname{r}(D_0)&<&1\\
   \operatorname{r}(A)&<&1
\end{array}
\end{equation*}
where $\operatorname{r}$ denotes the spectral radius.
\end{theorem}
The LMI version of this theorem can be formulated as 
\begin{theorem}\label{practical2}
The linear repetitive process described by (\ref{LRP}) is practically stable
if, and only if there exist matrices $P\succ 0$ and $Q\succ 0$ of appropriate dimensions such 
that the following LMI is feasible 
\begin{equation*}
\left[
\begin{array}{cc}
   A^TPA-P & 0\\
   0 & D_0^TQD_0
\end{array}\right]\prec 0
\end{equation*}
\end{theorem}

This notion of stability  is seldom used and hence will not be discussed in full detail --- see \cite{GramackiPHD}   

\subsection{STABILISATION}
If the system described by (\ref{LRP}) is unstable along the pass, 
it is necessery to stabilise it by means 
of an appropriate control action.  One of the control laws considered 
to date for discrete linear repetitive processes has the following 
structure (for the background see, for example,~\cite{Galkowski2003b} and the relevant cited
references)
\margin{The control law}
\begin{equation}\label{control_law}
u_{k + 1}(p) = K_{1} x_{k + 1}(p) + K_{2}  y_{k}(p) = K \left[
\begin{array}{c}
x_{k + 1}(p)\\
y_{k}(p) \end{array} \right],
\end{equation}
where $K_1$ and $K_2$ are matrices to be computed. Currently the
only effective approach for the computation of the controller
matrices is through the use of LMIs. First, define 
\begin{equation*}
\hat A_1 = \left[
\begin{array}{cc}
 A & B_0\\
 0 & 0
\end{array}
\right]
\end{equation*}
and
\begin{equation*}
\hat A_2 = \left[
\begin{array}{cc}
 0 & 0 \\
 C & D_0
\end{array}
\right]
\end{equation*}
In the Toolkit the following methods of obtaining $K_1$ and $K_2$ are implemented:
\begin{theorem}\cite{Galkowski2003b}
The linear repetitive process of (\ref{LRP}) with the applied control law of (\ref{control_law})
is stable along the pass if there exist matrices $Y=Y^T\succ 0$, $Z=Z^T\succ 0$ and $N$ such 
that the following LMI is feasible
\begin{equation*}
\begin{split}
\left[
	\begin{array}{cc}
		Z-Y & 0\\          
		0	& -Z   \\       
		\hat A_1*Y+\hat B_1*N & \hat A_2*Y+\hat B_2*N                
	\end{array}\right.\\
	\left.
	\begin{array}{rr}
		               &    Y*\hat A_1^T+N^T*\hat B_1^T\\
		           &    Y*\hat A_2^T+N^T*\hat B_2^T\\
		  &      -Y            
	\end{array}	
\right] \succ 0
\end{split}
\end{equation*}
where 
\begin{equation*}
\hat B_1 = \left[
\begin{array}{c}
 B  \\
  0 
\end{array}
\right]
\end{equation*}

\begin{equation*}
\hat B_2 = \left[
\begin{array}{c}
 0 \\
 D 
\end{array}
\right]
\end{equation*}
If the LMI is feasible, the controller $K$ is given by
\begin{equation}
K=NY^{-1}
\end{equation}
\end{theorem}
Proof of this theorem can be found in (\cite{Galkowski2003b})    
In the Toolkit this approach is implemented as \texttt{LMIAlongThePass1}.

Another variant of this method is to use
\begin{theorem}\cite{Galkowski2003b}
The linear repetitive process of (\ref{LRP}) with the applied control law of (\ref{control_law})
is stable along the pass if there exist matrices $P_1=P_1^T\succ 0$, $P_2=P_2^T\succ 0$, 
$P=P^T=\operatorname{diag}\{P_1,P_2\}\succ 0$, $N_1$ and $N_2$ such that the following LMI is feasible
\begin{equation*}
\left[
	\begin{array}{cccc}
		-P & \Phi P + RN\\
		P\Phi^T + N^T R^T& -P 
	\end{array}
\right]\succ 0
\end{equation*}
where 
\begin{equation*}
\Phi = \hat A_1 + \hat A_2
\end{equation*}
\begin{equation*}
N = 
\left[
\begin{array}{cc}
  N_1 & N_2 \\
  N_1 & N_2 \\  
\end{array}
\right]
\end{equation*}

If the above LMI is feasible, the controller $K$ is given by
\begin{equation}
K=NP^{-1}
\end{equation}
\end{theorem}
Again, the proof can be found in \cite{Galkowski2003b}. 
This method is implemented as \texttt{LMIAlongThePass2}



\chapter{THE LRP TOOLKIT}
\section{Alternatives}
A main problem encountered during the control related analysis of
repetitive processes is how to visualize the process dynamics. This
problem has been considered previously (see e.g.
\cite{GramackiPHD,Gramacki2005}) but the resulting software was
diffucult to extend and/or based on commercial environments.
Some of them can only be used for educational purposes.
The detailed discussion about available software packages for the
linear repetitive processes is given in \cite{CACSD}.
%
% for
% simulation in response to a given input sequence only and the
% underlying architecture did not allow new features to be added. Note
% also that the necessity to work under \textsc{Matlab} \cite{Matlab}
% and MS Windows family of operating systems has also been examined ---
% see~\cite{GramackiPHD}. This resulted in a Java
%  based version \cite{Gramacki2005} that can be run on all systems
% supporting Java Virtual Machine. This toolkit, however, has a number
% of constraints and hence its applicability is limited to educational
% purposes only. The \textsc{Matlab} version has an extensive number
% of discretization algorithms and provides methods of visualization
% of the process dynamics. This tool however does not cover the control
% law design.

\section{The LRP Toolkit}
The above arguments confirm that there is no high quality reliable
software to support the analysis and design of control laws for use
with, for example, experimental facilities,~\cite{Ratcliffe2005} where ILC
control laws designed in a repetitive process setting could be
experimentally verified. Moreover the currently available tools do
not allow easy inclusion of new algorithms.  Also there are no
software packages for analysis and synthesis based on open source
software (the Java-based toolkit \cite{Gramacki2005} cannot be used for
this purpose due to its limitations). This causes licensing problems
and reduces the areas of potential use (e.g. by students).

To overcome those limitations a development of a new Toolkit has been initiated.
To enhance the usefulness of this tool, the Scilab \cite{ScilabWWW} environment has been chosen.
\margin{Why Scilab?}
The main advantage of this option over other packages is the open-source license of the Scilab
and a rapidly growing number of users (including PSA Peugeot Citroen,
 Renault, Dassault Aviation and many others). The introduction to the Scilab
 environment is given in \cite{Gomez1999-1} and \cite{Campbell2006}. The LMI
 component, used in the Toolkit, is described in \cite{Nikoukhah-Scilab}.

% To be an effective in analysis and control design for repetitive
% processes, the developed Toolkit must offer the following key functional
% properties

% \begin{itemize}
%   \item Power --- the tool must include the best algorithms for stabilization and
%   stability analysis,
%   \item Extensibility --- by writing a minimal piece of code even an inexperienced programmer should be able to
%   include new control algorithms, stability analysis methods etc. as they are
%   developed,
%   \item Open source --- the toolkit must be based on an open source license,
%   \item Ease of use --- even a casual, non-professional user must be able to effectively utilize
%   the full potential of the tool,
%   \item \LaTeX{}{} export --- the results should be easily exported to the~\LaTeX{}{} system and
%   automatically produce a PDF file (when the user has installed a
% \LaTeX{}{} distribution),
%   \item The graphical user interface (GUI) must be separated from the core files ---
%   there must be no functional difference between using the GUI and the toolkit files directly.
%   This allows a user to create script files,
%   \item Ease of installation --- the toolkit itself should offer an easy-to-use installer, however
%   the source files must also be available.
% \end{itemize}
\margin{The main functions of the Toolkit}
The main functions of the implemented toolkit include:
\begin{itemize}
 \item Visualization of the process dynamics: 3D plots and 2D plots (both along the pass and
 pass-to-pass),
\item Stability analysis --- asymptotic and along the pass, using both classic (i.e. 
Nyquist diagram based) and LMI settings,
\item Control law design based on the use of LMIs~\cite{SulikowskiPHD,Galkowski2003b},
 \item Adding new analysis and control law design methods easily. The new methods are 
 automatically supported by the GUI.
\end{itemize}
%-------------------------------------------------------------------------------
\section{Installation}
\subsection{Requirements}
The LRP Toolkit requires
\begin{itemize}
    \item Scilab (\url{www.scilab.org}). Recommended version is Scilab-4.1 or later
    \item To use graphics user interface, the Scilab version with Tcl/Tk support 
    (almost all versions have this feature)
    \item About 4MB (megabyte; apprx. 1 million bytes) free disc space
%     \item For \LaTeX{} support, any \LaTeX{} distribution must be installed. 
%     For Windows, the MiKTeX (\url{www.miktex.org}) is recommended.
    \item The \scilab{gui} directory of the Toolkit must be granted the read and write rights. 
\end{itemize}
The Toolkit is distributed as a multi-platform ZIP file. It is possible to move the Toolkit \scilab{.sci} 
files between platforms.
\subsection{Windows}
The LRP Toolkit must be manually installed. The automatic installer will be available soon.
% \subsection{Automatic installation}
% It is recommended to use this method to install the Toolkit. 
% If after deinstallation the main directory of the Toolkit is empty, it will be 
% deleted as well. The installer uses the highly-reliable Nullsoft Installation System (NSIS) \ref{NSIS}.  
% For your convinience, the installer will add an Uninstall information into the Windows registry. 
% \subsection{Automatic deinstallation}
% To uninstall the Toolkit, run the \scilab{uninstall.exe} program.
% After using the provided
% uninstaller all Windows registry information is no longer needed and is removed.
% This program removes the Toolkit, without leaving any 
% leftover files. Note that if you change  anything in any Toolkit 
% file (except \scilab{.bin} and \scilab{html} files, which can be 
% easily recreated), during uninstallation phase you will be 
% asked if you want to remove  such file. This protects you 
% from accidently deleting your custom functions. 
%  
\subsection{Manual installation}
To install the Toolkit manually, unpack the ZIP file into any directory. The Scilab
team recommends the \scilab{contrib} subdirectory of the Scilab. 
After copying all the files, modify the \scilab{config} file with any text editor. 
\margin{The \scilab{config} file does not have any extension}
In this file, set the LRPHomeDir to point to the directory where the Toolkit is created. 
Modify other entries in this file as well.
\begin{warning}
  If you do not modify the \scilab{config} file, the Toolkit may not work properly.
\end{warning}
\subsection{Manual deinstallation}
To uninstall the Toolkit, simply delete its directory. Do not forget to 
save the files you modified, if you need them.
\section{Creating the LRP structure}
The LRP structure used by the Toolkit is quite complex. To
simplify creation of new structures, you can use three different methods (given from the 
simplest to the most complex):
\begin{itemize}
    \item use the graphics user interface
    \item use the \scilab{createLRPModel} function
    \item use the \scilab{createStubLRP} function and fill all the fields manually 
\end{itemize}
Each of those options will be covered in the corresponding subsections.

\subsection{Creating new LRP structure by using the graphics user interface}
This method is the preferred method of creating the LRP structure. It is 
the simplest and least error-prone approach. To create the structure, run the graphics user 
interface (fig.~\ref{MainForm}) by selecting the \scilab{Start GUI} from the LRP menu, 
shown as the item in the Scilab main menu. If there are no structure named \scilab{lrp}, it
will be automatically created. 
\begin{information}
The created structure is named \scilab{lrp}. Any other structure of this name is deleted.
If you need to preserve the old system, assingn it a different name, e.g. 
\scilab{myLrp = lrp;} 
\end{information}

\begin{information}
 If you cannot find the LRP menu, close the Scilab and run the Toolkit again. 
 If it does not work or you do not want to close the Scilab session, 
 run the \scilab{install.sci} script file by typing
  \begin{lstlisting}
    global LRP_OPTIONS;
    cd(LRP_OPTIONS.path);
    exec('install.sci');
  \end{lstlisting}
  The first two lines set the Toolkit directory. If you have problems with them,
  use the \scilab{cd(PATH_TO_LRP_TOOLKIT)}, where 
  \scilab{PATH_TO_LRP_TOOLKIT} is the directory where you installed the 
  LRP Toolkit --- if you are unsure about it, try the \scilab{contrib/lrp} directory in the main
  Scilab directory.   
\end{information}

You will now see the LRP Toolkit user interface, shown on fig.~\ref{MainForm}
\begin{figure}[!tb]
   \begin{center}
      \includegraphics[scale=0.7]{mainForm}
   \end{center}
   \caption{The main Toolkit GUI}
   \label{MainForm}
\end{figure}
To create a new LRP system, click \scilab{Create a new system} button, positioned in the
upper-left corner of the GUI. This will start the new system creator. You will need 
to give the following information:
\begin{itemize}
  \item the number of states ($n$), inputs ($r$) and outputs ($m$) in the system
  \item all the system matrices ($A$, $B$, $B0$, $C$, $D$, $D0$)
  \item the pass length $\alpha$ and the number of passes to simulate $\beta$.
\end{itemize}
To simplify entering the matrix' values click on the ellipsis button. Alternatively you may use the 
Scilab functions that return an appropriately-dimensioned matrix. 
\begin{warning}
If you use functions, you cannot use the ellipsis button. Moreover you are responsible for checking
the dimensions of matrices.
\end{warning}

\margin{Standard boundary conditions}
Note that the resulting process will have zero input and standard boundary conditions\index{Standard boundary conditions}
\begin{equation}
\label{boundaryConditions}
\begin{array}{rcl}
    x_{k + 1}(0) &=& 0,\: k \geq 0,\\
    y_{0}(p) &=& 1,
\end{array}
\end{equation}
You may change them using the \scilab{Initial conditions} button. 

To change the pass length and the number of simulated passes click the \scilab{Change parameters} 
button.

If any of the values were changed outside the Toolkit GUI, click \scilab{Update matrices} button
to feed the proper values into the GUI.

To close the GUI, click \scilab{Exit}.

\subsection{Creating new LRP structure by using \scilab{createLRPModel}}
This function is especially useful in scripts. This function can be called with
many different arguments. For detailed description type 
\scilab{help createLRPModel} in the Scilab window. 

To create a sample system use \scilab{lrp = createLRPModel();} 
The created system has 2 states, 3 inputs and 4 outputs. The system
matrices are random  from $0$ to $1$. The pass length $\alpha=10$ and number of 
simulated passes $\beta=15$. The external input $u$ equals zero.
To change the boundary conditions, see section \ref{SettingBoundaryConditions}.

\subsection{Creating new LRP structure by using \scilab{createStubLRP}}
If you need greater control over the creation process, use the \scilab{createStubLRP} function
to create the necessary fields. Then fill all the stub values with data.
\begin{warning}
If you do not fill all the stub values the Toolkit will not function correctly. To check
the correctness of the LRP structure, use the \scilab{checkLRP} function. 
\end{warning} 

\begin{warning}
Do not forget to set the \scilab{lrp.controllers} field!
\end{warning} 

\subsection{Setting the boundary conditions}\label{SettingBoundaryConditions}
To set the boundary conditions of the LRP structure named \scilab{lrp}, 
use the appropriate generator function:

\noindent For state $x$
\begin{itemize}
\item \scilab{lrp = boundCond_x1(lrp)} for $x_{k}(0)=1$
\item \scilab{lrp = boundCond_xsin(lrp)} for $x_{k}(0)$ of a sine 
wave of unit height and a period of one.
\item \scilab{lrp = boundCond_xsin(lrp,T)} for $x_{k}(0)$ of a sine 
wave of unit height and a period of \scilab{T}.
\end{itemize}

\noindent For output $y$
\begin{itemize}
\item \scilab{lrp = boundCond_y1(lrp)} for $y_{0}(p)=1$
\item \scilab{lrp = boundCond_ysin(lrp)} for $y_{0}(p)$ of a sine 
wave of unit height and a period of one.
\item \scilab{lrp = boundCond_ysin(lrp,T)} for $y_{0}(p)$ of a sine 
wave of unit height and a period of \scilab{T}.
\end{itemize}
%-------------------------------------------------------------------------------
\section{Visualization of the process dynamics}
The Toolkit can be used to visualise the process dynamics. 
All the standard methods of visualisation are available:
\subsection{Along the pass plots}
This plot is useful for showing the dynamics of the whole pass (along the $p$ dimension).
It is also very important tool for comparing the shape of a few passes. 

This plot emphasizes the $p$ direction. To draw this plot, the user must first select 
the pass $k$ for which the plot is to be made. Upto $32$ passes can be shown simultanously.   
On the $X$ points $p$ are shown,  the value is given on the $Y$ axis.    
The example of such plot is shown on figure~\ref{ExampleAlongThePassPlot}.
\begin{figure}[tb]
   \begin{center}
      \hspace*{-2cm]}\includegraphics[scale=0.6]{outputafter.pdf}
   \end{center}
   \caption{Along the pass plot example}
   \label{ExampleAlongThePassPlot}
\end{figure}

\subsection{Pass to pass plot}
This plot is useful for showing the change of dynamics over all passes for a 
selected point $p$. 

This plot emphasizes the $k$ direction. To draw this plot, the user must first select 
the point $p$ for which the plot is to be made. Upto $32$ points can be shown simultanously.   
On the $X$ passes $k$ are shown,  the value is given on the $Y$ axis.    
The example of such plot is shown on figure~\ref{ExamplePassToPassPlot}.
\begin{figure}[tb]
   \begin{center}
      \hspace*{-2cm]}\includegraphics[scale=0.6]{outputafter.pdf}
   \end{center}
   \caption{Pass to pass plot example}
   \label{ExamplePassToPassPlot}
\end{figure}


\section{IMPROVEMENTS}
Since the release of the first version of the LRP Toolkit (see \cite{CACSD})
a vast number of bugs have been fixed. Currently the new release of the Toolkit
is available. The most important change is that the functions that do not depend on the
considered model structure have been rewritten to accept a much more general
parameters. This makes extension of the Toolkit much easier in practice.

After the initial release it became obvious that much stronger type checks
are required. This is motivated by a fact that the linear repetitive process
 model contains many variables that are error-prone.
 This has lead to a development of new functions for dealing with
this task.

Currently the great effort is made towards new, vastly improved help system.
This is based on standard Scilab templates, but contains many more illustrative
examples. Moreover a number of potential pitfalls is explained. All such cases
have a suggested, valid solution.

Very much attention has been paid to presentation of the results. In the new version of the Toolkit, the drawing engine has been rewritten to allow much
easier use in scripts  --- all the functions have a much clearer syntax.  Moreover, the plotting routines
 have been extended to handle the degenerate cases (like a plot of single point on a
 single pass). 
 Due to~readibility, a maximum of $32$ passes can be drawn
simultaneously using different colors for clarity. 
%  Additionally, due to the extended \LaTeX{}{} support, creating
%  multiple plots is much faster (from O(n) to O(1) calculations of plot surfaces),
%  moreover the plot surface is calculated only for data required for plotting
%  --- when user requests an "along the pass" plot for points 7..18 for
%  $\alpha=100$ only the first 18 points are calculated. If necessary, it can be requested
%  to calculate the entire surface.
Compared to the previous version, the 3D plots are now made in full color to
better visualize the range of values in the plot.  
 
% During development it became clear that the $lrp$ structure is (due to its size)
% displayed ineffectively. Therefore a new display operators have been provided for
% all types defined in the Toolkit. Unfortunately, due to a bug (or undocumented
% feature) in Scilab only the first 8 characters of the type name in the
% overloaded funcion are compared. To overcome this behaviour all the Toolkit's
% type names have a common, 8 characters prefix of \textit{lrp\_Sys\_}.
% 
% Moreover the "classic" LRP type has been changed to simplify modifications.
% Its main fields are \textit{dim} (model dimensions, number of passes etc.),
%  \textit{mat} (all the system matrices) and \textit{ini} (the initial conditions).
%  Rest of the data is used internally by the Toolkit.
%  

%  - strong type checking
%  oddzielenie ogolnych funkcji od tych zwiazanych z konkretnym modelem
% modulowosc
%  helpy pod scilaba, rozbudowane
%  plot for degenerated cases
%  zmiana struktury LRP - modulowosc
%  nowa funkcja do wykresów
%
%  lrpPlotOPT.Xlabel='zonker'
%  lrpPlotOPT.Ylabel='zonkerY'
%  lrpPlotOPT.Zlabel='zonkerY'
%  lrpPlotOPT.title='zonkerY'
%  lrpPlotOPT.color=list(


% As the platform for developing software for analysis and control law
% design/evaluation to remove these difficulties, the free and open
% resource ~\textsc{Scilab} (see \cite{ScilabWWW,
% Gomez1999-1,Campbell2006}) has been selected. \textsc{Scilab}
% environment has been under development since 1990 by INRIA (France)
% and has already seen industrial use (e.g. PSA Peugeot Citroen,
% Renault, Dassault Aviation and many others). Moreover, it supports
% MS Windows and Linux/Unix operating systems and, due to the fact
% that it is an open source software, can be compiled on any required
% operating system. Using the \textsc{Scilab} in comparision to
% writing the software from scratch, e.g. in the C++ language, has
% many benefits and, in particular, ease of programming. The
% disadvantage of \textsc{Scilab}'s current version is the lack of the support for the
% object oriented programming, the use of limited
% Tool Command Language/Toolkit (TCL/TK) libraries and (most
% importantly) the lack of ``by variable'' parameter passing to
% functions.


%==================================================================================================================
%==================================================================================================================
%\subsection{FUNCTIONALITY}

% After the installation, the Toolkit can be run by using MS Windows {\textit{Start}} menu and then selecting an
% option in the \textsc{Scilab} menu. After launching, the \textsc{Scilab} the Toolkit's GUI (Fig. \ref{main}) is run.
%==================================================================================================================
% \subsection{VISUALIZATION} A very important part of the toolkit is the visualization of the process dynamics engine. It
% allows the user to generate various plots that greatly increase the
% understanding of a process dynamics. All relevant dynamics plots can
% be produced, including along the pass and the pass-to-pass plots.
% Moreover, a 3D visualization of the overall evolution of the process
% dynamics is available. These plots show how the state or output
% (pass profile) evolve during the execution of the selected sequence
% of passes. Note also that all supported plots can be generated
% separately for both the outputs and states.
%
%  Due to~\textsc{Scilab} 3.x constraints, a maximum of $6$ passes can be drawn
% simultaneously using different colors for clarity. Creating a
% pass-to-pass plot is almost identical to its along the pass
% counterpart. Both along the pass and the pass-to-pass plots include
% a legend. The selections of passes or points can be made using a
% simple GUI. The same result can be however  obtained by using
% provided toolkit functions, which is especially useful for scripting
% purposes.
%
% The 3D plots module is used to construct a three-dimensional view of
% the process dynamics, simultaneously showing the along and
% pass-to-pass directions. In other words, 3D plots enable
% visualization of the full evolution of the process dynamics over the
% specified number of passes. To construct such a plot it is necessary
% to choose the state/output number which is to be visualized. The
% plot is then generated for all included points and passes (i.e.
% \mbox{$\forall k \in \{0,1,\ldots,\beta\}$} and \mbox{$\forall p \in
% \{0,1,\ldots,\alpha-1\}$}
% --- see (\ref{LRP})) where $\beta$ denotes the user-specified number of passes.
%
% All plots utilize a standard set of the \textsc{Scilab} tools and
% hence share the benefits and constraints of this environment. For
% example the most important problem with plotting in \textsc{Scilab}
% is a fact that in some circumstances the plot cannot be rotated
% accurately enough. To overcome this problem the implemented toolkit
% provides an utility function \texttt{rotateFig} that allows a given
% plot to be rotated by any specified degree.
% %==================================================================================================================
\subsection{STABILITY ANALYSIS}
In terms of stability analysis for discrete linear repetitive
processes of the form considered here, asymptotic stability (and
hence the construction of the resulting limit profile described by a
1D discrete linear systems state space model) is simple to check by means of Theorem 
\ref{asymptotic1}, as it requires that all eigenvalues of the matrix $D_{0}$
in~(\ref{LRP}) have modulus strictly less than unity (this task is
much harder for the case when the pass initial condition is an
explicit function of the previous pass profile.) Asymptotic stability
 test is implemented in the Toolkit as the \texttt{stAsymptotic1} test.
Its LMI counterpart of Theorem \ref{asymptotic2} is also implemented. 
This function is termed \texttt{stAsymptoticLMI1}.    

Stability along the pass, however, is a much more challenging 
task in this respect. In which context, it has been noted in 
the introduction that a 1D Nyquist test can be used but it has not proved a suitable basis to
undertake control law design (in contrast to the 1D case).  This has
led to the use of LMI based tests (see Theorem \ref{th:stab:none:1}) 
which are sufficient but not necessary but can be executed using computations with constant entry
matrices and, crucially, provide a basis for control law design. 
To test the stability along the pass in the Toolkit by means of 
Theorem \ref{th:stab:none:1}, the \texttt{stAlongThePassLMI1} test can
be utilised.  

In addition to the most important stability definitions (asymptotic and along the pass), 
the Toolkit includes the tests for the so-called practical stability. This notion lies 
between the asymptotic and along the pass stability. The tests implemented according to
Theorems \ref{practical1} and \ref{practical2} are available as \texttt{stPractical1} and
\texttt{stPracticalLMI1}, respectively.    
 

Both stability properties can be investigated using the LMI technique.
One of the reasons of selecting the Scilab as the host platform for the Toolkit 
was the excellent  LMI solver available for this platform as 
"\textsc{LMITOOL}: a Package for LMI Optimization in Scilab"
\cite{Nikoukhah-Scilab}. Note also that
provision is available to easily include existing or newly developed
tests by simply implementing a single~\textsc{Scilab} function with
no need to change the GUI, which is shown on fig. \ref{stabilityGUI}. 
\begin{figure}[!bt]
   \begin{center}
      \includegraphics[scale=0.9]{stability.pdf}
   \end{center}
   \caption{Stability analysis window}
   \label{stabilityGUI}
\end{figure}
%
% %==================================================================================================================
\subsection{CONTROL LAW DESIGN}\label{stabilisingcontrollerdesign}

As outlined in the Background section, the stabilisation of the linear repetive process
is not always easy. In developing new techniques it is beneficial to compare the 
newly developed method with the ones already known. One approach would be to use the LMI tools already available in~\textsc{Scilab} and code the methods by hand.
However, this approach requires substantial knowledge about the
internal data structures used by the LMI solver and this is not
ideal. Consequently a set of ready-to-use control law design
templates have been incorporated into the toolkit. Moreover,
expanding it by adding additional control law design methods is a
simple task.
% %==================================================================================================================
% \subsection{\LaTeX{}{} EXPORT}
% 
% Presentation of simulation results can be a time consuming task,
% especially when considering large matrices which are often
% encountered in this area. To simplify this tedious task the toolkit
% has been equipped with \LaTeX{}{} export capabilities. An essential novelty is
% the fact that the user needs to write the \LaTeX{}{} file, adding the tags that
% will be replaced by the simulation results, instead of using a complicated syntax of the previous Toolkit version.
% It is possible to include any number of plots, both 2D and 3D. On each plot any
% number of points/passes can be displayed, which is an essential
% difference with the "interactive" plots discussed earlier. Note
% however that 32 points/passes on each plot can be
% displayed in unique colors --- a great improvement over the previous version. The process of plot selection is
% simplified by the use of an interactive wizard. It is also possible
% to export simulation data from the script.
% %===============================================================================
\subsection{USABILITY ENCHANCEMENTS}
One of the design goals was to make this new toolkit as user
friendly as possible. To achieve this, a "new system wizard" for
entering various process parameters has been implemented. Since most
of the model parameters are matrices, the basic method to define
these is the \textsc{Scilab} convention for entering matrices
(exactly the same as in the \textsc{Matlab}). To simplify this
process, it is also possible to enter the matrix element-by-element
(see Fig. \ref{MatrixWizard}).

\begin{figure}[!tb]
   \begin{center}
      \includegraphics[scale=0.6082]{MatrixWizard.pdf}
   \end{center}
   \caption{Matrix wizard windows: main and the matrix entry}
   \label{MatrixWizard}
\end{figure}
% To make the end product available for a broader audience, the
% Windows operating system version employs an easy to use multilingual
% (currently Polish and English) installer based on {\textit{Nullsoft
% Install System}} (\textit{NSIS}) \cite{NSIS}. This system is widely
% regarded to be a very reliable, free solution that produces a small
% overhead code. Additionally, the \textit{NSIS} can package and
% verify all the files included into the prepared compilation.
% Moreover, as an additional safety measure, for each installed file
% the Message-Digest Algorithm 5 (better known as MD5) checksum is
% calculated using the \textit{MD5~library} \cite{MD5Plugin}. This value is
% used when upgrading and uninstalling the toolkit --- if any change
% is detected, the user can choose to leave the file intact.
% Essentially, this feature provides protection against accidental
% deletion of manual changes.
% 
% During the installation phase, an existing \LaTeX{}{} installation is
% automatically detected. Currently, the most popular
% {\textit{MiKTeX}} distribution is supported by the installer, but
% any standard \LaTeX{}{} can be used.
%===============================================================================
\section{IMPLEMENTATION DETAILS}
The toolkit consists of a TCL/TK GUI frontend and a number of
\textsc{Scilab} script files and functions. All the basic process
parameters are included in the \texttt{lrp} structure which is
implemented as a new type based on the \texttt{tlist} (typed list;
native \textsc{Scilab} datatype) with the following fields:
\begin{itemize}
   \item \texttt{lrp}\underscorett\texttt{Sys}\underscorett\texttt{Cla} --- (\texttt{string}), name of the data type
    \item The \texttt{lrp.mat} field of type  \texttt{lrp}\underscorett\texttt{Sys}\underscorett\texttt{Cla}\underscorett\texttt{Mat} used
    for storing the model matrices --- see (\ref{LRP}). Currently it contains the values of 
   \texttt{A}, \texttt{B}, \texttt{B0}, \texttt{C}, \texttt{D}, \texttt{D0} ---
   \item The \texttt{lrp.dim} field of type  \texttt{lrp}\underscorett\texttt{Sys}\underscorett\texttt{Cla}\underscorett\texttt{Dim} used for storing the model dimensions. Currently it has the following fields
   \begin{itemize}
       \item \texttt{alpha} --- (\texttt{positive integer}), pass length (number of points on each pass),
       denoted $\alpha$ in (\ref{LRP}),
       \item \texttt{beta} ---  (\texttt{positive integer}), number of passes over which the simulation will run,
       \item \texttt{n}, \texttt{r}, \texttt{m} --- (\texttt{positive integers}), dimensions of state, input and
       output vectors respectively,
   \end{itemize}
   \item The \texttt{lrp.ini} field of type  \texttt{lrp}\underscorett\texttt{Sys}\underscorett\texttt{Cla}\underscorett\texttt{Ini} used for storing the initial conditions. Currently it has two fields:
   \item \texttt{x0}, \texttt{y0} --- (\texttt{real matrices}), boundary conditions, see (\ref{boundaryConditions}). Note
   that $x_{k+1}(0)$ in (\ref{boundaryConditions}) is here denoted by \texttt{x0} for simplicity,
   \item \texttt{controller} --- (\texttt{list}), list of known control laws for the process; see below,
   \item \texttt{indController} --- (\texttt{positive integer}), index of current control law. This field
   contains the index of currently active control law. If \texttt{indController=1} then no control law is applied.
   \item \texttt{stability} --- (\texttt{list}), list of performed stability tests; see below.
\end{itemize}
Note that the model of~(\ref{LRP}) does not impose any constrains on
the number of passes and hence
   to simulate the process response it is necessary to bound it by some finite value selected by the user ---
   hence the parameter \texttt{beta} in the \texttt{lrp} structure.
\subsection{THE \textbf{lrp.controller} FIELD}
The \texttt{controller} field of the
\texttt{lrp}\underscorett\texttt{Sys}\underscorett\texttt{Cla} datatype is a dynamically
increasing \texttt{list} that contains a number of \texttt{tlist}
structures. Each element holds the results of control law
calculations.
 By design the first element of the \texttt{controller} list (i.e \texttt{lrp.controller(1)}) is
a copy of all the system matrices. This ,,controller'' is necessary for retaining
the matrices for the open-loop system.

When new control law matrices are computed, a new \texttt{tlist} is
added to the \texttt{lrp.controller} field. This field is defined by
the user and the toolkit does not enforce any constraints on its
structure. The only requirement is that there must be a field
\texttt{solutionExists} of the \texttt{boolean} type which informs whether or
not it is possible to obtain
 control law matrices for the example under consideration by the design method being considered.

In order to introduce a new control law the user must 1) give it a
name (e.g. \texttt{controllerExample}) and 2) implement a set of 3
functions and one \texttt{.tex} file:
\begin{itemize}
  \item \texttt{controllerExample} (the same name as a control law name) ---
  the main function used for calculating the (constant) control law matrices
  given a process state space model. This approach
  allows faster calculations but also imposes an important drawback --- it is not possible
  (without changes to the core Toolkit files)
  to simulate controlled process to asses the effects of varying the control law matrix ($K$). (LMI designs produce a
  family of such $K$).  The addition of this feature is a subject for future work.
  \item \texttt{setcontrollerExample} (\texttt{set}+controller name) ---
  change the system matrices to depict the controlled process (e.g.
  replace the $A$ matrix into $A+B\cdot K$ matrix where $K$ is the calculated (constant) control law matrix).
  \item \texttt{writecontrollerExample} (\texttt{write}+controller name) --- a \textsc{Scilab} function
  for exporting the results (e.g. controller matrices, parameters etc.) to \LaTeX{}{}, can be blank if no export is required
  Note. The \LaTeX{} support is disabled in this version but will be available soon.
  \item \texttt{describecontrollerExample.tex} (\texttt{describe}+controller name) --- introductory
  text in \LaTeX{}{} to be inserted when using the \LaTeX{}{} export capabilities, can be left blank.
\end{itemize}
It must be stressed that the Toolkit files written by the user must
be placed in the appropriate directories --- this is explained in
the help file. Note also that the \textsc{Scilab} enforces a maximum
function name length of $25$ characters.

% Currently the toolkit functions contain only slight overhead code
% which is mainly due to various checks of given arguments.  All
% calculations are performed by native \textsc{Scilab} commands. The
% only exception is the GUI which, due to the used TCL/TK language
% (the only option for \textsc{Scilab} version 3x),
% cannot compete in terms of speed with the direct execution of
% the toolkit functions called from the console. This does not, however, reduce the usefulness of this tool,
% since the GUI is used for small (or, at most, medium) sized problems
% for which this overhead is negligible.

%===============================================================================
\subsection{THE \textbf{lrp.stability} FIELD}
The \texttt{stability} field of the \texttt{lrp}\underscorett\texttt{Sys}\underscorett\texttt{Cla} datatype
is a dynamically increasing \texttt{list} that contains a number of \texttt{tlist}
structures. Each element represents a preformed stability test.

When the user checks a new stability condition, a new \texttt{tlist}
is added to the \texttt{lrp.stability} field. This field is defined
by the programmer and the toolkit does not enforce any constrains on
its structure. The only requirement is that there must be a field
\texttt{solutionExists} of integer type (note here the difference
between \texttt{lrp.stability} and \texttt{lrp.controller} field
where a \texttt{boolean} type is used instead) which informs the user whether
the system is stable, unstable or the method used does not provide
the answer. The \texttt{solutionExists} field can have the following
values
\begin{itemize}
 \item $-1$ - test is inconclusive. In this case the only
 alternative is to use another test.
 \item $0$ - the process is unstable,
 \item $1$ - the process is stable.
\end{itemize}
Obviously the \textsc{Scilab} works in finite precision arithmetic and hence numerical errors
can influence the results.

To implement a stability test the programmer should write a function
that returns an \texttt{lrp} structure and is given one as the only
argument. Note here that a better solution would be to use a ``by
variable'' (or by pointer) passing method but this is not
implemented in \textsc{Scilab}. This function must be placed in the
\texttt{stability} directory of the toolkit.

To conserve memory, the \texttt{lrp.stability} field is dynamically
created. If the user does not complete any stability tests then this
field does not exist.
%===============================================================================
\subsection{THE BOUNDARY CONDITIONS}
The boundary conditions of (\ref{boundaryConditions}) can be entered either as a set of values, or by providing a function
that returns the appropriate value given the pass $k$ and point number $p$.

By default, if the user does not supply the boundary conditions, they are assumed as 
\begin{equation*}
\begin{array}{rcl}
    x_{k + 1}(0) &=& 0\\
    y_{0}(p) &=& 1
\end{array}
\end{equation*}
%===============================================================================
\section{THE COOLMATRIX TYPE}
The conducted usability tests have shown that, due to differences in indexing between the 
theoretical results and the Scilab requirements, the implementation of any function can very easily lead to the
famous "fencepost" error --- for example, if the user wants to see pass number 3 he has to enter the index $4$ in  
the Scilab matrix. While this problem may seem simple, it can lead to many difficult-to-detect errors, especially
for non-standard LRP systems (like the "wave" processes, where negative indices are often used).

To overcome this difficulty, the new version of the Toolkit includes the $CoolMatrix$ 
matrix type that allows the user to index the arrays as required (from $0$ or any other value, including negative number).
The functions used for this type are designed for fast prototyping and hence provide a strict error checking ---
any attempt to use a wrong index causes an error. Great effort has been made to make this type compatible with 
the standard Scilab matrix type. The disadvantage of this addition to the Toolkit is 
the overhead caused by this type. This fact does not very significant, as the 
type is aimed at the prototyping phase, where a small to medium problems are tested. 
Moreover, the experience shows that the efficiency of the Toolkit is greatly dependent on the 
LMI solver, which has the greatest impact in the practical applications. 

To create the CoolMatrix variable, the user must provide the allowed range of indices. 
Note here that the Scilab notation of "extending" the size of the matrix when called with 
index larger than its former size is not supported, as this is very error-prone. 
%===============================================================================
\chapter{Example}
To illustrate the LRP Toolkit, consider the special case of~(\ref{LRP})
defined by the following matrices
%\begin{small}
\begin{align*}
A&=
\begin{bmatrix}
     0.19 &  0.07 &  0.19 \\
     0.02 &  0.85 &  0.49 \\
     0.84 &  0.01 &  0.75
\end{bmatrix},
B=
\begin{bmatrix}
     0.8 \\
     0.7 \\
     0.3
\end{bmatrix},
B_0=
\begin{bmatrix}
     0.1 &  0.2 \\
     0.3 &  0.1 \\
     0.6 &  0.2
\end{bmatrix},\\
C&=
\begin{bmatrix}
     0.5 &  0.3 &  0.1 \\
     0.2 &  0.4 &  0.1
\end{bmatrix},
D=
\begin{bmatrix}
     0.2 \\
     0.4
\end{bmatrix},
D_0=
\begin{bmatrix}
     0.44 &  0.26 \\
     0.08 &  0.07
\end{bmatrix}.
\end{align*}
%\end{small}
with pass length $\alpha=10$ and boundary conditions
%\begin{small}
\begin{align*}
y_0(p)&=
\left[
\begin{array}{cc}
  \sin(p)& \sin(p)
\end{array}
\right]^T \quad \text{for}\quad 0\leq p<\alpha,
\\
x_k(0)&=\left[
\begin{array}{ccc}
  0.9  &  0.9  &   0.9
\end{array}
\right]^T
\quad \text{for} \quad k \geq 0.
\end{align*}
%\end{small}
(Note that the argument of the $\sin$ function is given in radians).

By using the stability analysis options offered by the toolkit we
conclude that the process is asymptotically stable but unstable
along the pass. The plots of the pass profiles for $k=3,\; 5,\; 7,
\; 12, \;15, \;20$ confirm this (note the amplitudes of pass profile
vectors increase significantly (see Fig.
\ref{stabilityAlongThePassPlot}) as the process dynamics evolve).
\begin{figure}[tb]
   \begin{center}
      \includegraphics[scale=0.4]{outputbefore.pdf}
   \end{center}
   \caption{Instability along the pass --- output 1 along the pass}
   \label{stabilityAlongThePassPlot}
\end{figure}

Suppose now that the task is to design a control law of the
form~(\ref{control_law}) to ensure stability along the pass. This
can be undertaken using the toolkit stabilizing control law design
options, as detailed in Section~\ref{stabilisingcontrollerdesign}.
For demonstration purposes we consider the case (in actual fact the
theory behind this design produces a family of possible choices for
$K$) when the control law matrix $K$ of~(\ref{control_law}) is given
by
%\begin{small}
{\setlength\arraycolsep{2.2pt}
  \begin{equation*}
  K=\left[
   \begin{array}{ccccc}
    -0.4887 & -0.5174 & -0.6102 & -0.4543 & -0.2739
 \end{array}
   \right].
  \end{equation*}
}
% \end{small}
Note here that the user does not have to execute any commands to
compute the resulting controlled process state space model --- this
is automatically done.  The resulting controlled stable along the
pass process state space model is of the form~(\ref{LRP}) with
%\begin{small}
{\setlength\arraycolsep{2.2pt}
\begin{align*}
&A=
\begin{bmatrix}
    -0.201 & -0.3439 & -0.2982 \\
    -0.3221 &  0.4878 &  0.06287 \\
     0.6934 & -0.1452 &  0.5669
\end{bmatrix},
B\!=\!
\begin{bmatrix}
     0.8 \\
     0.7 \\
     0.3
\end{bmatrix},\\
&B_0\!=\!
\begin{bmatrix}
    -0.2634 & -0.01911 \\
    -0.01802 & -0.09172 \\
     0.4637 &  0.1178
\end{bmatrix},
D_0\!=\!
\begin{bmatrix}
     0.3491 &  0.2052 \\
    -0.1017 & -0.03956
\end{bmatrix}\!,%
\\
&C=
\begin{bmatrix}
     0.4023 &  0.1965 & -0.02204 \\
     0.004519 &  0.193 & -0.1441
\end{bmatrix},
D=
\begin{bmatrix}
     0.2 \\
     0.4
\end{bmatrix}.
\end{align*}
}
%\end{small}
All the matrices obtained during the control law  computations are
available to the user by using the options supplied. 
% and they can be
% also exported to the \LaTeX{}{}-based source file.

A representative plot of the evolution of the pass profile sequence
for the controlled process is given in Fig.
\ref{stabilityAlongThePassPlot} and the stability along the pass
property is evident by inspection.

\begin{figure}[!bt]
   \begin{center}
      \includegraphics[scale=0.38]{outputafter.pdf}
   \end{center}
   \caption{Stability along the pass --- controlled process output 1 along the pass}
   \label{stabilityAlongThePassPlotAfter}
\end{figure}
%===============================================================================
\section{CONCLUSIONS AND FUTURE WORK}
The \textsc{Scilab} toolkit whose development has been described in
this paper has already been useful in the analysis and control law
design for discrete linear repetitive processes of the form
considered here. Its basic functions include the simulation engine
and the stability analysis/control law design abilities. A key point
to note is that this toolkit removes the limitations present in
others. 
% Moreover, the user is able to export the results to the
% valid \LaTeX{}{} compatible format text file.

Software development for this toolkit is an ongoing process; there
are many options which remain to be implemented. A representative
sample of on going development work is the following topics:
\begin{itemize}
  \item removing of Scilab bug with TCL/TK interface (CRITICAL!) 
  \item a \LaTeX{} support (mostly done but still requires a bit of testing). 
  \item support for new classes of processes (such as "wave" or semi-linear) and for a differential process model
  where the dynamics along the pass are governed by a linear matrix differential equation couple along with
  discretization methods,
  \item addition new control law design algorithms,
  \item control law design for stability and performance  (e.g. ensuring that a reference signal is tracked,
  minimization of the influence of the external disturbances),
  \item handling of processes with uncertainty in the state space model,
  \item an installer for the Linux/Unix version.
\end{itemize}
Results from this work will be reported in due course.

\chapter{Appendix}
\section{Abbreviations and notation}
Throughout the manual the following abbreviations and notations are used\medskip\\
\noindent
\begin{tabular}{r|l}
Notation & Meaning\\\hline
   GUI    & Graphics user interface \\
   LRP    & Linear Repetitive Process or \\
          & \hspace*{1em} type of a structure used by the Toolkit to represent such process \\
  $\succ$ & positive definitiveness of a matrix \\
  $\prec$ & negative definiteness of a matrix \\
  $r(M)$ & the spectral radius, the largest module of an eigenvalue of matrix $M$ 
\end{tabular}
\bibliographystyle{alpha}
\bibliography{ExtendedControllability}
\printindex
\end{document}
